diff --git a/pki/base/common/src/com/netscape/cmscore/ldap/LdapRule.java b/pki/base/common/src/com/netscape/cmscore/ldap/LdapRule.java
index f3d2bd17fc8d03041e938199643bbe6b548cef1d..0f0c3a3b9cbf9ed9db56cf8f81b058c28d55f9ec 100644
--- a/pki/base/common/src/com/netscape/cmscore/ldap/LdapRule.java
+++ b/pki/base/common/src/com/netscape/cmscore/ldap/LdapRule.java
@@ -83,13 +83,14 @@ public class LdapRule implements ILdapRule, IExtendedPluginInfo {
         }
 
         epi_params = new String[] {
-                    "type;choice(cacert,crl, certs);The publishing object type",
-                    "mapper;choice(" + map + ");Use the mapper to find the ldap dn \nto publish the certificate or crl",
-                    "publisher;choice(" + publish
-                            + ");Use the publisher to publish the certificate or crl a directory etc",
-                    "enable;boolean;Enable this publishing rule",
-                    "predicate;string;Filter describing when this publishing rule shoule be used"
-                };
+                "type;choice(cacert,crl, certs);The publishing object type",
+                "mapper;choice("
+                        + map + ");Use the mapper to find the ldap dn \nto publish the certificate or crl",
+                "publisher;choice("
+                        + publish + ");Use the publisher to publish the certificate or crl a directory etc",
+                "enable;boolean;Enable this publishing rule",
+                "predicate;string;Filter describing when this publishing rule shoule be used"
+        };
 
         // Read the predicate expression if any associated
         // with the rule
@@ -115,12 +116,12 @@ public class LdapRule implements ILdapRule, IExtendedPluginInfo {
         mConfig = config;
 
         epi_params = new String[] {
-                    "type;choice(cacert, crl, certs);The publishing object type",
-                    "mapper;choice(null,LdapUserCertMap,LdapServerCertMap,LdapCrlMap,LdapCaCertMap);Use the mapper to find the ldap dn to publish the certificate or crl",
-                    "publisher;choice(LdapUserCertPublisher,LdapServerCertPublisher,LdapCrlPublisher,LdapCaCertPublisher);Use the publisher to publish the certificate or crl a directory etc",
-                    "enable;boolean;",
-                    "predicate;string;"
-                };
+                "type;choice(cacert, crl, certs);The publishing object type",
+                "mapper;choice(null,LdapUserCertMap,LdapServerCertMap,LdapCrlMap,LdapCaCertMap);Use the mapper to find the ldap dn to publish the certificate or crl",
+                "publisher;choice(LdapUserCertPublisher,LdapServerCertPublisher,LdapCrlPublisher,LdapCaCertPublisher);Use the publisher to publish the certificate or crl a directory etc",
+                "enable;boolean;",
+                "predicate;string;"
+        };
 
         // Read the predicate expression if any associated
         // with the rule
diff --git a/pki/base/common/src/com/netscape/cmscore/logging/LogSubsystem.java b/pki/base/common/src/com/netscape/cmscore/logging/LogSubsystem.java
index 83cd0c99c601dded6427069b2291f3613bb96387..8ac304f8c7d04f5d3258bfd15c8a4d1310e9b38b 100644
--- a/pki/base/common/src/com/netscape/cmscore/logging/LogSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/logging/LogSubsystem.java
@@ -139,8 +139,8 @@ public class LogSubsystem implements ILogSubsystem {
                 throw new EBaseException(insName + ":Failed to instantiate class " + className);
             } catch (Throwable e) {
                 e.printStackTrace();
-                throw new EBaseException(insName + ":Failed to instantiate class " + className + " error: "
-                        + e.getMessage());
+                throw new EBaseException(insName
+                        + ":Failed to instantiate class " + className + " error: " + e.getMessage());
             }
 
             if (insName == null) {
diff --git a/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java b/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
index 5bedafbe088e039b4ec6b040a3e43ddef5eca4a6..68556dfc00d083ce677ccf8d7f3800f80f98a885 100644
--- a/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
+++ b/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
@@ -24,7 +24,6 @@ import java.security.cert.X509Certificate;
 import java.util.Enumeration;
 
 import netscape.security.x509.CertificateExtensions;
-import netscape.security.x509.GeneralName;
 import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.RevokedCertImpl;
@@ -187,18 +186,15 @@ public class ReqCertSANameEmailResolver implements IEmailResolver {
                             GeneralNames gn =
                                     (GeneralNames) ext.get(SubjectAlternativeNameExtension.SUBJECT_NAME);
 
-                            Enumeration e = gn.elements();
+                            Enumeration<GeneralNameInterface> e = gn.elements();
 
                             while (e.hasMoreElements()) {
-                                Object g = (Object) e.nextElement();
-
-                                GeneralName gni =
-                                        (GeneralName) g;
+                                GeneralNameInterface gni = e.nextElement();
 
                                 if (gni.getType() == GeneralNameInterface.NAME_RFC822) {
                                     CMS.debug("got an subjectalternatename email");
 
-                                    String nameString = g.toString();
+                                    String nameString = gni.toString();
 
                                     // "RFC822Name: " + name
                                     mEmail =
diff --git a/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java b/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
index 936a466ccf594ef2ba718d3520411b57ac3808dd..42bb3e68e43b62ef723a12d5ad07875219a0fd39 100644
--- a/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
+++ b/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
@@ -42,7 +42,8 @@ public class PluginRegistry implements IPluginRegistry {
     private IConfigStore mConfig = null;
     private IConfigStore mFileConfig = null;
     private ISubsystem mOwner = null;
-    private Hashtable<String, Hashtable<String, IPluginInfo>> mTypes = new Hashtable<String, Hashtable<String, IPluginInfo>>();
+    private Hashtable<String, Hashtable<String, IPluginInfo>> mTypes =
+            new Hashtable<String, Hashtable<String, IPluginInfo>>();
 
     public PluginRegistry() {
     }
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
index bd47f3ce68a386928fe617d8f87f93a52c03d982..82739debf8db57044bd70a8760520f02b2097742 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
@@ -30,6 +30,7 @@ import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Iterator;
 import java.util.Locale;
+import java.util.Map;
 import java.util.Set;
 import java.util.Vector;
 
@@ -168,7 +169,7 @@ public abstract class ARequestQueue
      * @return
      *         an Enumeration that generates RequestId objects.
      */
-    abstract protected Enumeration getRawList();
+    abstract protected Enumeration<RequestId> getRawList();
 
     /**
      * protected access for setting the current state of a request.
@@ -435,7 +436,7 @@ public abstract class ARequestQueue
             throw new EBaseException("Missing agent information");
 
         aas.addApproval(agentName);
-        r.setExtData(AgentApprovals.class.getName(), aas.toStringVector());
+        r.setExtData(AgentApprovals.class.getName(), (Vector<?>) aas.toStringVector());
 
         PolicyResult pr = mPolicy.apply(r);
 
@@ -878,7 +879,9 @@ class Request
             if (!((key instanceof String) && isValidExtDataKey((String) key))) {
                 return false;
             }
-
+            /*
+             * 	TODO  should the Value type be String?
+             */
             Object value = hash.get(key);
             if (!(value instanceof String)) {
                 return false;
@@ -900,12 +903,13 @@ class Request
         return true;
     }
 
-    public boolean setExtData(String key, Hashtable value) {
+    @SuppressWarnings("unchecked")
+    public boolean setExtData(String key, Hashtable<String, String> value) {
         if (!(isValidExtDataKey(key) && isValidExtDataHashtableValue(value))) {
             return false;
         }
 
-        mExtData.put(key, new ExtDataHashtable(value));
+        mExtData.put(key, new ExtDataHashtable<String>(value));
         return true;
     }
 
@@ -924,7 +928,7 @@ class Request
         return (String) value;
     }
 
-    public Hashtable getExtDataInHashtable(String key) {
+    public Hashtable<String, String> getExtDataInHashtable(String key) {
         Object value = mExtData.get(key);
         if (value == null) {
             return null;
@@ -932,10 +936,10 @@ class Request
         if (!(value instanceof Hashtable)) {
             return null;
         }
-        return new ExtDataHashtable((Hashtable) value);
+        return new ExtDataHashtable<String>((Hashtable<String, String>) value);
     }
 
-    public Enumeration getExtDataKeys() {
+    public Enumeration<String> getExtDataKeys() {
         return mExtData.keys();
     }
 
@@ -954,9 +958,10 @@ class Request
             return false;
         }
 
-        Hashtable existingValue = (Hashtable) mExtData.get(key);
+        @SuppressWarnings("unchecked")
+        Hashtable<String, String> existingValue = (Hashtable<String, String>) mExtData.get(key);
         if (existingValue == null) {
-            existingValue = new ExtDataHashtable();
+            existingValue = new ExtDataHashtable<String>();
             mExtData.put(key, existingValue);
         }
         existingValue.put(subkey, value);
@@ -964,11 +969,11 @@ class Request
     }
 
     public String getExtDataInString(String key, String subkey) {
-        Hashtable value = getExtDataInHashtable(key);
+        Hashtable<String, String> value = getExtDataInHashtable(key);
         if (value == null) {
             return null;
         }
-        return (String) value.get(subkey);
+        return value.get(subkey);
     }
 
     public boolean setExtData(String key, Integer value) {
@@ -1226,7 +1231,7 @@ class Request
         return certArray;
     }
 
-    public boolean setExtData(String key, Vector stringVector) {
+    public boolean setExtData(String key, Vector<?> stringVector) {
         String[] stringArray;
         if (stringVector == null) {
             return false;
@@ -1239,12 +1244,12 @@ class Request
         return setExtData(key, stringArray);
     }
 
-    public Vector getExtDataInStringVector(String key) {
+    public Vector<String> getExtDataInStringVector(String key) {
         String[] stringArray = getExtDataInStringArray(key);
         if (stringArray == null) {
             return null;
         }
-        return new Vector(Arrays.asList(stringArray));
+        return new Vector<String>(Arrays.asList(stringArray));
     }
 
     public boolean getExtDataInBoolean(String key, boolean defVal) {
@@ -1265,11 +1270,11 @@ class Request
         if (data == null) {
             return false;
         }
-        Hashtable hash = new Hashtable();
-        Enumeration keys = data.getElements();
+        Hashtable<String, String> hash = new Hashtable<String, String>();
+        Enumeration<String> keys = data.getElements();
         while (keys.hasMoreElements()) {
             try {
-                String authKey = (String) keys.nextElement();
+                String authKey = keys.nextElement();
                 hash.put(authKey, data.getInString(authKey));
             } catch (ClassCastException e) {
                 return false;
@@ -1279,12 +1284,12 @@ class Request
     }
 
     public IAuthToken getExtDataInAuthToken(String key) {
-        Hashtable hash = getExtDataInHashtable(key);
+        Hashtable<String, String> hash = getExtDataInHashtable(key);
         if (hash == null) {
             return null;
         }
         AuthToken authToken = new AuthToken(null);
-        Enumeration keys = hash.keys();
+        Enumeration<String> keys = hash.keys();
         while (keys.hasMoreElements()) {
             try {
                 String hashKey = (String) keys.nextElement();
@@ -1360,7 +1365,7 @@ class Request
         if (values == null) {
             return false;
         }
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         for (int index = 0; index < values.length; index++) {
             hashValue.put(Integer.toString(index), values[index]);
         }
@@ -1370,7 +1375,7 @@ class Request
     public String[] getExtDataInStringArray(String key) {
         int index;
 
-        Hashtable hashValue = getExtDataInHashtable(key);
+        Hashtable<String, String> hashValue = getExtDataInHashtable(key);
         if (hashValue == null) {
             String s = getExtDataInString(key);
             if (s == null) {
@@ -1380,10 +1385,10 @@ class Request
                 return sa;
             }
         }
-        Set arrayKeys = hashValue.keySet();
-        Vector listValue = new Vector(arrayKeys.size());
-        for (Iterator iter = arrayKeys.iterator(); iter.hasNext();) {
-            String arrayKey = (String) iter.next();
+        Set<String> arrayKeys = hashValue.keySet();
+        Vector<Object> listValue = new Vector<Object>(arrayKeys.size());
+        for (Iterator<String> iter = arrayKeys.iterator(); iter.hasNext();) {
+            String arrayKey = iter.next();
             try {
                 index = Integer.parseInt(arrayKey);
             } catch (NumberFormatException e) {
@@ -1395,7 +1400,7 @@ class Request
             listValue.set(index,
                     hashValue.get(arrayKey));
         }
-        return (String[]) listValue.toArray(new String[0]);
+        return listValue.toArray(new String[0]);
     }
 
     public IAttrSet asIAttrSet() {
@@ -1415,7 +1420,7 @@ class Request
     protected String mOwner;
     protected String mRequestType;
     protected String mContext; // string for now.
-    protected ExtDataHashtable mExtData = new ExtDataHashtable();
+    protected ExtDataHashtable<Object> mExtData = new ExtDataHashtable<Object>();
 
     Date mCreationTime = CMS.getCurrentDate();
     Date mModificationTime = CMS.getCurrentDate();
@@ -1448,7 +1453,7 @@ class RequestIAttrSetWrapper implements IAttrSet {
         mRequest.deleteExtData(name);
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mRequest.getExtDataKeys();
     }
 }
@@ -1478,7 +1483,7 @@ class RequestListByStatus
         return null;
     }
 
-    public Object nextElement() {
+    public RequestId nextElement() {
         RequestId next = mNext;
 
         update();
@@ -1494,7 +1499,7 @@ class RequestListByStatus
         return next;
     }
 
-    public RequestListByStatus(Enumeration e, RequestStatus s, IRequestQueue q) {
+    public RequestListByStatus(Enumeration<RequestId> e, RequestStatus s, IRequestQueue q) {
         mEnumeration = e;
         mStatus = s;
         mQueue = q;
@@ -1511,7 +1516,7 @@ class RequestListByStatus
             if (!mEnumeration.hasMoreElements())
                 break;
 
-            rId = (RequestId) mEnumeration.nextElement();
+            rId = mEnumeration.nextElement();
 
             try {
                 IRequest r = mQueue.findRequest(rId);
@@ -1527,7 +1532,7 @@ class RequestListByStatus
 
     protected RequestStatus mStatus;
     protected IRequestQueue mQueue;
-    protected Enumeration mEnumeration;
+    protected Enumeration<RequestId> mEnumeration;
     protected RequestId mNext;
 }
 
@@ -1537,7 +1542,7 @@ class RequestList
         return mEnumeration.hasMoreElements();
     }
 
-    public Object nextElement() {
+    public RequestId nextElement() {
         return mEnumeration.nextElement();
     }
 
@@ -1553,11 +1558,11 @@ class RequestList
         return null;
     }
 
-    public RequestList(Enumeration e) {
+    public RequestList(Enumeration<RequestId> e) {
         mEnumeration = e;
     }
 
-    protected Enumeration mEnumeration;
+    protected Enumeration<RequestId> mEnumeration;
 }
 
 class RecoverThread extends Thread {
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java b/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
index f21503a21006760eb12cf13eb7089d6347be06cd..86e6c0530b6db66c208d489e384de9268b288d36 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
@@ -10,7 +10,7 @@ import java.util.Set;
  * purpose is to hide the fact that LDAP doesn't preserve the case of keys.
  * It does this by lowercasing all keys used to access the Hashtable.
  */
-public class ExtDataHashtable extends Hashtable {
+public class ExtDataHashtable<V> extends Hashtable<String, V> {
 
     /**
      *
@@ -29,7 +29,7 @@ public class ExtDataHashtable extends Hashtable {
         super(i, v);
     }
 
-    public ExtDataHashtable(Map map) {
+    public ExtDataHashtable(Map<? extends String, ? extends V> map) {
         // the super constructor seems to call putAll, but I can't
         // rely on that behaviour
         super();
@@ -44,7 +44,7 @@ public class ExtDataHashtable extends Hashtable {
         return super.containsKey(o);
     }
 
-    public Object get(Object o) {
+    public V get(Object o) {
         if (o instanceof String) {
             String key = (String) o;
             return super.get(key.toLowerCase());
@@ -52,7 +52,7 @@ public class ExtDataHashtable extends Hashtable {
         return super.get(o);
     }
 
-    public Object put(Object oKey, Object val) {
+    public V put(String oKey, V val) {
         if (oKey instanceof String) {
             String key = (String) oKey;
             return super.put(key.toLowerCase(), val);
@@ -60,15 +60,15 @@ public class ExtDataHashtable extends Hashtable {
         return super.put(oKey, val);
     }
 
-    public void putAll(Map map) {
-        Set keys = map.keySet();
-        for (Iterator i = keys.iterator(); i.hasNext();) {
+    public void putAll(Map<? extends String, ? extends V> map) {
+        Set<? extends String> keys = map.keySet();
+        for (Iterator<? extends String> i = keys.iterator(); i.hasNext();) {
             Object key = i.next();
-            put(key, map.get(key));
+            put((String) key, map.get(key));
         }
     }
 
-    public Object remove(Object o) {
+    public V remove(Object o) {
         if (o instanceof String) {
             String key = (String) o;
             return super.remove(key.toLowerCase());
diff --git a/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java b/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
index a3637758f411c4b108053f125e4cf2593b060dea..c7f8c493a0e13a82382229fa922cc3fb50364a27 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
@@ -250,7 +250,7 @@ public class RequestRecord
             if (value instanceof String) {
                 r.setExtData(key, (String) value);
             } else if (value instanceof Hashtable) {
-                r.setExtData(key, (Hashtable) value);
+                r.setExtData(key, (Hashtable<String, String>) value);
             } else {
                 throw new EDBException("Illegal data value in RequestRecord: " +
                         r.toString());
diff --git a/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java b/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
index aa80a3cebb07a75a2f17687c118ce2d83a00e661..a4f6ee9a02cb0e6f1054dab2ccf40d3435872f68 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
@@ -127,8 +127,9 @@ public final class JssSubsystem implements ICryptoSubsystem {
     protected PasswordCallback mPWCB = null;
 
     private static JssSubsystem mInstance = new JssSubsystem();
-    private Hashtable mNicknameMapCertsTable = new Hashtable();
-    private Hashtable mNicknameMapUserCertsTable = new Hashtable();
+    private Hashtable<String, X509Certificate[]> mNicknameMapCertsTable = new Hashtable<String, X509Certificate[]>();
+    private Hashtable<String, X509Certificate[]> mNicknameMapUserCertsTable =
+            new Hashtable<String, X509Certificate[]>();
 
     private FileInputStream devRandomInputStream = null;
 
@@ -144,7 +145,7 @@ public final class JssSubsystem implements ICryptoSubsystem {
     private static final String PROP_SSL_CIPHERPREF = Constants.PR_CIPHER_PREF;
     private static final String PROP_SSL_ECTYPE = Constants.PR_ECTYPE;
 
-    private static Hashtable mCipherNames = new Hashtable();
+    private static Hashtable<String, Integer> mCipherNames = new Hashtable<String, Integer>();
 
     /* default sslv2 and sslv3 cipher suites(all), set if no prefs in config.*/
     private static final String DEFAULT_CIPHERPREF =
@@ -514,12 +515,13 @@ public final class JssSubsystem implements ICryptoSubsystem {
 
     public String getTokenList() throws EBaseException {
         String tokenList = "";
-        Enumeration tokens = mCryptoManager.getExternalTokens();
+        @SuppressWarnings("unchecked")
+        Enumeration<CryptoToken> tokens = mCryptoManager.getExternalTokens();
         int num = 0;
 
         try {
             while (tokens.hasMoreElements()) {
-                CryptoToken c = (CryptoToken) tokens.nextElement();
+                CryptoToken c = tokens.nextElement();
 
                 // skip builtin object token
                 if (c.getName() != null && c.getName().equals("Builtin Object Token")) {
@@ -603,10 +605,11 @@ public final class JssSubsystem implements ICryptoSubsystem {
         String certNames = "";
 
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+            Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
-                CryptoToken token = (CryptoToken) enums.nextElement();
+                CryptoToken token = enums.nextElement();
                 CryptoStore store = token.getCryptoStore();
                 X509Certificate[] list = store.getCertificates();
 
@@ -1155,12 +1158,13 @@ public final class JssSubsystem implements ICryptoSubsystem {
     public NameValuePairs getRootCerts() throws EBaseException {
         NameValuePairs nvps = new NameValuePairs();
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+            Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
             if (mNicknameMapCertsTable != null)
                 mNicknameMapCertsTable.clear();
 
             // a temp hashtable with vectors
-            Hashtable vecTable = new Hashtable();
+            Hashtable<String, Vector<X509Certificate>> vecTable = new Hashtable<String, Vector<X509Certificate>>();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1183,11 +1187,11 @@ public final class JssSubsystem implements ICryptoSubsystem {
                         X509CertImpl impl = null;
 
                         try {
-                            Vector v;
+                            Vector<X509Certificate> v;
                             if (vecTable.containsKey((Object) nickname) == true) {
-                                v = (Vector) vecTable.get(nickname);
+                                v = vecTable.get(nickname);
                             } else {
-                                v = new Vector();
+                                v = new Vector<X509Certificate>();
                             }
                             v.addElement(list[i]);
                             vecTable.put(nickname, v);
@@ -1208,11 +1212,11 @@ public final class JssSubsystem implements ICryptoSubsystem {
                     }
                 }
                 // convert hashtable of vectors to hashtable of arrays
-                Enumeration elms = vecTable.keys();
+                Enumeration<String> elms = vecTable.keys();
 
                 while (elms.hasMoreElements()) {
                     String key = (String) elms.nextElement();
-                    Vector v = (Vector) vecTable.get((Object) key);
+                    Vector<X509Certificate> v = vecTable.get((Object) key);
                     X509Certificate[] a = new X509Certificate[v.size()];
 
                     v.copyInto((Object[]) a);
@@ -1231,7 +1235,8 @@ public final class JssSubsystem implements ICryptoSubsystem {
     public NameValuePairs getUserCerts() throws EBaseException {
         NameValuePairs nvps = new NameValuePairs();
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+            Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1297,7 +1302,8 @@ public final class JssSubsystem implements ICryptoSubsystem {
             mNicknameMapUserCertsTable.clear();
 
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+            Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1378,36 +1384,36 @@ public final class JssSubsystem implements ICryptoSubsystem {
         }
 
         // a temp hashtable with vectors
-        Hashtable vecTable = new Hashtable();
+        Hashtable<String, Vector<X509Certificate>> vecTable = new Hashtable<String, Vector<X509Certificate>>();
 
         for (int i = 0; i < certs.length; i++) {
             String nickname = certs[i].getNickname();
 
             /* build a table of our own */
-            Vector v;
+            Vector<X509Certificate> v;
 
             if (vecTable.containsKey((Object) nickname) == true) {
-                v = (Vector) vecTable.get(nickname);
+                v = vecTable.get(nickname);
             } else {
-                v = new Vector();
+                v = new Vector<X509Certificate>();
             }
             v.addElement(certs[i]);
             vecTable.put(nickname, v);
         }
 
         // convert hashtable of vectors to hashtable of arrays
-        Enumeration elms = vecTable.keys();
+        Enumeration<String> elms = vecTable.keys();
 
         while (elms.hasMoreElements()) {
             String key = (String) elms.nextElement();
-            Vector v = (Vector) vecTable.get((Object) key);
+            Vector<X509Certificate> v = vecTable.get((Object) key);
             X509Certificate[] a = new X509Certificate[v.size()];
 
             v.copyInto((Object[]) a);
             mNicknameMapCertsTable.put(key, a);
         }
 
-        Enumeration keys = mNicknameMapCertsTable.keys();
+        Enumeration<String> keys = mNicknameMapCertsTable.keys();
 
         while (keys.hasMoreElements()) {
             String nickname = (String) keys.nextElement();
diff --git a/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java b/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
index 6d7d71b0e440d3b821941524c849662f0d6e6c64..1d03911b45f2be6a225961f4886bab15af932e57 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
@@ -156,7 +156,8 @@ public class KeyCertUtil {
     public static String getTokenNames(CryptoManager manager)
             throws TokenException {
         String tokenList = "";
-        Enumeration tokens = manager.getExternalTokens();
+        @SuppressWarnings("unchecked")
+        Enumeration<CryptoToken> tokens = manager.getExternalTokens();
         int num = 0;
 
         while (tokens.hasMoreElements()) {
@@ -981,7 +982,7 @@ public class KeyCertUtil {
         String signing = properties.getOCSPSigning();
 
         if ((signing != null) && (signing.equals(Constants.TRUE))) {
-            Vector oidSet = new Vector();
+            Vector<ObjectIdentifier> oidSet = new Vector<ObjectIdentifier>();
             oidSet.addElement(
                     ObjectIdentifier.getObjectIdentifier(
                             ExtendedKeyUsageExtension.OID_OCSPSigning));
